Helipad = "unLoaded";
Flag = "unLoaded";
Icon = "unLoaded";
IconType = "PrisonerIcon";
HeliType = "Prisoner_Helicopter"
--Global var located here and in Helipad. If changed, changed both.
PairDistance = 10;
Delay = 30; -- The Delay between Spawned helicopter leaving the map and another avalible
function Create()
    Set("HelipadID","None");
    Set("HeliID","None");
    Set("FlagID","None");
    Set("IconID","None");
    Set("HeliStatus","None");
    Set("Spawn", false);
	Set("NumOfPrisoners",1);
	Set("Category",2);
	Set("TooltipCategory","Normal");
    Set("Version","v3.0");
end

function Update(timePassed)
    --Save against Corruption
    if Get("Version") ~= "v3.0" then
		Set("NumOfPrisoners",1);
		Set("Category",2);
		Set("TooltipCategory","Normal");
		Set("Version","v3.0");
    end
-------------------------------------------------------------------------------------------
-- Load References
-------------------------------------------------------------------------------------------
    Flag = Load(Flag,"HeliFlag","FlagID",1000000);   
    Helipad = Load(Helipad,"Helipad","HelipadID",PairDistance);
    Icon = Load(Icon,IconType,"IconID",2);
    if Get("IconID") == "None" then
        Icon = Object.Spawn(IconType,this.Pos.x-0.02,this.Pos.y-1.1);
        Set("IconID",Icon.Id.i);
    end
    -- Find a Helipad else Set/Get info on Helipad
    if Get("HelipadID") == "None" then
        objs = Object.GetNearbyObjects("Helipad",PairDistance);
        for o , d in pairs(objs) do
            if Get("HelipadID") == "None" then
                Helipad = o;
                Set("HelipadID",Helipad.Id.i);
            end
        end
    else
    --Check to see Helipad has been deleted.
        if GetObject("Helipad",Get("HelipadID"),PairDistance) == nil then
            Set("HelipadID","None");
            Helipad = "unLoaded";
        end
    end           
-------------------------------------------------------------------------------------------
-- Spawn Flag and Helicopter
-------------------------------------------------------------------------------------------      
    if Get("Spawn") then                

        --Wait until Flag has reached edge of map.
        if Get("FlagID") ~= "None" and Get("HeliID") == "None" then
            if GetFrom(Flag,"ReachedEdge") == true then
                local flagX = GetFrom(Flag,"Pos.x");
                local flagY = GetFrom(Flag,"Pos.y");        
                --Create Heli, Store ID and Destination.
                Heli = Object.Spawn(HeliType,flagX,flagY);
                Set("HeliID",Heli.Id.i);
                SetOn(Heli,"HelipadID",Helipad.Id.i);
                SetOn(Heli,"FlagID",Flag.Id.i);
                SetOn(Heli,"ControlID",this.Id.i);
                SetOn(Heli,"Destination","Helipad");
                Set("Tooltip","tooltip_heliControl_OnRoute");
            end
        end
    end
-------------------------------------------------------------------------------------------
-- Check if activated
-------------------------------------------------------------------------------------------
    -- If we have a referenced Helipad then Display the call button
    if Helipad ~= "unLoaded" and GetFrom(Helipad,"InUse") == false then
		this.AddInterfaceComponent("ControlBtn1","Button", "Call Helicopter");
		this.AddInterfaceComponent("PlusBtn", "Button", "Plus");
		this.AddInterfaceComponent("MinusBtn", "Button", "Minus");	
		this.AddInterfaceComponent("HigherRiskBtn", "Button", "Higher Risk");
		this.AddInterfaceComponent("LowerRiskBtn", "Button", "LowerRisk");		
    else
		this.RemoveInterfaceComponent("ControlBtn1");
		this.RemoveInterfaceComponent("PlusBtn");
		this.RemoveInterfaceComponent("MinusBtn");
		this.RemoveInterfaceComponent("HigherRiskBtn");
		this.RemoveInterfaceComponent("LowerRiskBtn");	
	end
-------------------------------------------------------------------------------------------
-- Helicopter Status Response
-------------------------------------------------------------------------------------------
    -- HeliStatus is set by the helicopter.
    if Get("HeliID") ~= "None" then
        if Get("HeliStatus") == "Arrived" then
            Set("Tooltip","tooltip_heliControl_OnRoute");
        elseif Get("HeliStatus") == "Waiting" then
            Set("Tooltip","tooltip_heliControl_Waiting");
        elseif Get("HeliStatus") == "Fueling" then
            Set("Tooltip","tooltip_heliControl_Fueling");
        elseif Get("HeliStatus") == "Leaving" then
            Set("Tooltip","tooltip_heliControl_Leaving");
        elseif Get("HeliStatus") == "LeftMap" then            
            Set("HeliID","None");
            Set("HeliStatus","None")
            Set("Spawn",false);
            if Get("HelipadID") ~= "None" then
                SetOn(Helipad,"Delay",Delay);
                SetOn(Helipad,"InUse",false);
            end
            Set("FlagID","None");
        end
    elseif Get("HeliID") == "None" then
        if Get("HelipadID") ~= "None" then
            if GetFrom(Helipad,"InUse") == false then
                this.Tooltip = "Use the panel to Call in new prisoners,\nYou can also adjust the amount to Fly in.\nPrisoners: ".. Get("NumOfPrisoners").."\nCategory: "..Get("TooltipCategory");
            else
                Set("Tooltip","tooltip_heliControl_InUse");
            end
        else
            Set("Tooltip","tooltip_heliControl_Cancled");
            Set("Spawn",false);
        end
    end
    SetOn(Icon,"Tooltip","Prisoners: ".. Get("NumOfPrisoners"));
-------------------------------------------------------------------------------------------
-- Keep the flag Alive while Helicopter is on map
-------------------------------------------------------------------------------------------
    if Get("FlagID") ~= "None" then
        SetOn(Flag,"life",0.0);
    end
-------------------------------------------------------------------------------------------
-- Keep the Icon Alive while im on the map
-------------------------------------------------------------------------------------------
    if Get("IconID") ~= "None" then
        SetOn(Icon,"life",0.0);
    end
end




function ControlBtn1Clicked()
	this.RemoveInterfaceComponent("ControlBtn1", "Call Helicopter");
	Set("Spawn",true);
        --Conditions to Spawn the Helicopter
        if GetFrom(Helipad,"InUse") == false and tonumber(GetFrom(Helipad,"Delay")) <= 0 then
            --Spawn a flag for Helicopter to spawn on.
                Flag = Object.Spawn("HeliFlag",0,GetFrom(Helipad,"Pos.y"));
                Set("FlagID",Flag.Id.i);
			--Make sure the Helipad can not be used while I are using it
                SetOn(Helipad,"InUse",true);
				Print(Get("NumOfPrisoners"));
        end
end
function PlusBtnClicked()
	Set("NumOfPrisoners",Get("NumOfPrisoners")+1);
	if Get("NumOfPrisoners")>6 then
		Set("NumOfPrisoners", 6);
	end
	Print(Get("NumOfPrisoners"));
end
function MinusBtnClicked()
	Set("NumOfPrisoners",Get("NumOfPrisoners")-1);
	if Get("NumOfPrisoners")<=1 then
		Set("NumOfPrisoners",1);
	end
	Print(Get("NumOfPrisoners"));
end
function HigherRiskBtnClicked()
	Set("Category",Get("Category")+1);
	if Get("Category")>3 then
		Set("Category",3);
	end
	UpdateTooltipCategory()
end
function LowerRiskBtnClicked()
	Set("Category",Get("Category")-1);
	if Get("Category")<1 then
		Set("Category",1);
	end
	UpdateTooltipCategory()
end

function UpdateTooltipCategory()
	if Get("Category") == 1 then
		Set("TooltipCategory", "Min Sec");
	elseif Get("Category") == 2 then
		Set("TooltipCategory", "Med Sec");
	elseif Get("Category") == 3 then
		Set("TooltipCategory", "Max Sec");
	end
end













    --Helper Functions
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end--]]


-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "unLoaded" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
    return Object;
end