-- For all
Flag = "";
Helipad = "";
Control = "";
FuelToLeave = 3; --Default = 3
-- For this only
--EntityMin = 2; --Default = 2
--EntityMax = 8; --Default = 8
function Create()
    -- For all
    Set("HelipadID","None");
    Set("FlagID","None");
    Set("ControlID","None");
    Set("Destination","None");
    Set("HeliStatus","Arrived");
    Set("Version","v2.0");
    Set("PosX",0);
    Set("PosY",0);
    Set("FuelLevel",0);
    Set("Tooltip","tooltip_helicopter_Moving");
    -- For this only
    Set("Sec",5);
end

function Update(timePassed)
-------------------------------------------------------------------------------------------
-- Load References
-------------------------------------------------------------------------------------------
    Flag = Load(Flag,"HeliFlag","FlagID",100000);
    Helipad = Load(Helipad,"Helipad","HelipadID",1000000);
    Control = Load(Control,"Prisoner_HeliControl","ControlID",1000000);
    
    -- If Helipad has beed removed then.;
    if GetObject("Helipad",Get("HelipadID"),1000000) == nil then
        Set("HeliStatus","Leaving");
        Set("Destination","Flag");
    end
    
    -- If Control Terminal has beed removed then.;
    if GetObject("Prisoner_HeliControl",Get("ControlID"),1000000) == nil then
        SetOn(Helipad,"InUse",false);
        this.Delete(this);
    end
-------------------------------------------------------------------------------------------
-- Fly to Helipad
-------------------------------------------------------------------------------------------     
    if Get("Destination") == "Helipad" then  
        Set("HeliStatus","Arrived");
        GoTo(Helipad,5,timePassed);
        if AtDest(Helipad,1.5) then
			EntityMin = GetFrom(Control,"NumOfPrisoners");
			EntityMax = GetFrom(Control,"NumOfPrisoners");
            SpawnEntities("Prisoner",EntityMin,EntityMax,-2,1,true);
            Set("Destination","None");
            Set("HeliStatus","Fueling")
            Set("PosX",this.Pos.x);
            Set("PosY",this.Pos.y);
        end
-------------------------------------------------------------------------------------------
-- Fly to Flag
-------------------------------------------------------------------------------------------   
    elseif Get("Destination") == "Flag" then
        Set("SubType", 1);
        GoTo(Flag,5,timePassed);
        if AtDest(Flag,2) then
            Set("HeliStatus","LeftMap");
            Object.Delete(this);
        end
-------------------------------------------------------------------------------------------
-- Stationary
------------------------------------------------------------------------------------------- 
    elseif Get("Destination") == "None" then
        this.Pos.x = Get("PosX");
        this.Pos.y = Get("PosY");
-------------------------------------------------------------------------------------------
-- Fueling
------------------------------------------------------------------------------------------- 
        if GetFrom(Control,"HeliStatus") == "Fueling" then
            Set("Tooltip","tooltip_helicopter_Fueling");
            if not Get("DeployedPilot") then
                Pilot = SpawnEntities("Pilot",1,1,0,0);
                Set("PilotID",Pilot.Id.i);
                Set("DeployedPilot",true);
            end
            if tonumber(Get("FuelLevel")) < FuelToLeave then
                this.CreateJob("FuelTank");
            else
                if Get("DeployedPilot") then
                    Pilot = GetObject("Pilot",Get("PilotID"),8)
                    Object.Delete(Pilot);
                    Set("HeliStatus","Leaving");
                end
            end       
        end
-------------------------------------------------------------------------------------------
-- Waiting //Not used here
-------------------------------------------------------------------------------------------
        if GetFrom(Control,"HeliStatus") == "Waiting" then
            if tonumber(Get("DeployedGuards")) <= 0 then
                Set("HeliStatus","Leaving");
            end       
        end
-------------------------------------------------------------------------------------------
-- Leaving
-------------------------------------------------------------------------------------------
        if GetFrom(Control,"HeliStatus") == "Leaving" then
            Set("Tooltip","tooltip_helicopter_Moving");
            Set("Destination","Flag");       
        end
    end
    SetOn(Control,"HeliStatus",Get("HeliStatus"));
end

function JobComplete_FuelTank()
    Set("FuelLevel",Get("FuelLevel")+1);
end
-------------------------------------------------------------------------------------------
-- Spawning
-------------------------------------------------------------------------------------------
function SpawnEntities(entity,minE,maxE,rPosX,rPosY,isSpread)
    local spread = isSpread or false;
    local countEntity = math.max(math.random(maxE),minE);
    --if countEntity > 0 then spawn a Entity else countEntity = "";
    local EntList = {};
    for i = 1, countEntity do
        if spread then
            Entity = Object.Spawn(entity,Helipad.Pos.x+rPosX+i-1,Helipad.Pos.y+rPosY);
			Entity.Category = GetFrom(Control,"Category");
            EntList[#EntList+1] = Entity;
        else
            Entity = Object.Spawn(entity,Helipad.Pos.x+rPosX-1,Helipad.Pos.y+rPosY);
            EntList[#EntList+1] = Entity;
        end
        SetOn(Entity,"HelicopterID",this.Id.i);
    end
    if countEntity > 1 then
        return EntList;
    elseif countEntity == 1 then
        return Entity;
    end
end


function AtDest(dest,r)
    if -r <= GetFrom(dest,"Pos.x")-Get("Pos.x") and -r-2 <= GetFrom(dest,"Pos.y")-Get("Pos.y")
    and GetFrom(dest,"Pos.x")-Get("Pos.x") <= r and GetFrom(dest,"Pos.y")-Get("Pos.y") <= r+2 then
        Print("Reached Pad");
        Set("Destination","None");
        return true;
    end
    return false;
end

function GoTo(object,speed,dT)
    local destX = GetFrom(object,"Pos.x");
    local destY = GetFrom(object,"Pos.y");
    local difX = destX - this.Pos.x;
    local difY = destY - this.Pos.y;
    
    --Move left and Right
    if difX > 0.3 then
        this.Pos.x = this.Pos.x + speed * dT;
    elseif difX < -0.3 then
        this.Pos.x = this.Pos.x - speed * dT;
    end
   
    xMagnitude = math.abs(difX)
    if xMagnitude > 0.5 then
        if xMagnitude > 35 and difY < 4 then
            this.Pos.y = this.Pos.y - 0.4 * dT;
        else        
        --this sends it down       
            if difY > 0.3 then
                this.Pos.y = this.Pos.y + difY/xMagnitude * dT;
            elseif difY < -0.3 then
                this.Pos.y = this.Pos.y - difY/xMagnitude *dT;
            end
        end
    end
end


-------------------------------------------------------------------------------------------
-- Helper Functions
------------------------------------------------------------------------------------------- 
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end--]]


-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
    return Object;
end