RiotGuard = "";
Helicopter = "";
HelicopterPosX = 0;
HelicopterPosY = 0;
IdlePosX = 0;
IdlePosY = 0;
DestX = 0;
DestY = 0;
Attacking = false;
Patroling = true;
IdleTime = 0;
Patience = 240;

function Create()
    Set("CanLeave",false);
    Set("RiotGuardID","None");
    Set("HelicopterID","None");   
end

function Update(timePassed)
-------------------------------------------------------------------------------------------
-- Load References
-------------------------------------------------------------------------------------------    
    if Get("RiotGuardID") == "None" then
        RiotGuard = Object.Spawn("RiotGuard",Get("Pos.x")+1,Get("Pos.y"));
		RiotGuard.AddInterfaceComponent("LeaveBtn","Button", "Decommission");
        Set("RiotGuardID",RiotGuard.Id.i);
        RiotGuard.Carrying.i = this.Id.i
		RiotGuard.Carrying.u = this.Id.u
		this.CarrierId.i = RiotGuard.Id.i
		this.CarrierId.u = RiotGuard.Id.u    
    end
    
    RiotGuard = Load(RiotGuard,"RiotGuard","RiotGuardID",10000);
    Helicopter = Load(Helicopter,"Riot_Helicopter","HelicopterID",10000);
    
    if GetObject("Riot_Helicopter",Get("HelicopterID"),10000) == nil then
        Object.Delete(RiotGuard);
        Object.Delete(this);
    end
    if IdlePosX == 0 then
        IdlePosX = RiotGuard.Pos.x;
        IdlePosY = RiotGuard.Pos.y;
    end
    if Helicopter ~= nil then
        HelicopterPosX = Helicopter.Pos.x;
        HelicopterPosY = Helicopter.Pos.y;
    end
-------------------------------------------------------------------------------------------
-- Check if Prisoners nearby are Misbehaving
-------------------------------------------------------------------------------------------    
    Prisoners = Object.GetNearbyObjects("Prisoner",8)
    if len(Prisoners) >= 1 then
        for Prisoner, Dist in pairs(Prisoners) do
            if Attacking == false then
                SetOn(RiotGuard,"Tooltip","Target is "..tostring(Prisoner.Misbehavior));
                if Prisoner.Misbehavior == "Misbehaving" 
                or Prisoner.Misbehavior == "Escaping" 
                or Prisoner.Misbehavior == "Destroying" 
                or Prisoner.Misbehavior == "Spoiling" 
                or Prisoner.Misbehavior == "Fighting" 
                or Prisoner.Misbehavior == "Rioting" then
                    RiotGuard.TargetObject.i = Prisoner.i;
                    RiotGuard.TargetObject.u = Prisoner.u;
                    Attacking = true;
                    Patroling = false;
                end
            end
        end
    end
-------------------------------------------------------------------------------------------
-- Attack Prisoners nearby that are Misbehaving
-------------------------------------------------------------------------------------------   
    if Attacking then
        if tonumber(RiotGuard.TargetObject.i) == -1 and tonumber(RiotGuard.TargetObject.u) == -1 then
            Patroling = true;
            Attacking = false;
            IdlePosX = RiotGuard.Pos.x;
            IdlePosY = RiotGuard.Pos.y;
        end
        SetOn(RiotGuard,"Tooltip","tooltip_riotGuard_Attack");
        IdleTime = 0;
    end
-------------------------------------------------------------------------------------------
-- Idle on the spot if no action
-------------------------------------------------------------------------------------------       
    if tonumber(RiotGuard.PlayerOrderPos.x) <= 0.1 and tonumber(RiotGuard.PlayerOrderPos.y) <= 0.1 then
        if Attacking == false then
            if Patroling then
                RiotGuard.Pos.x = IdlePosX;
                RiotGuard.Pos.y = IdlePosY;
                SetOn(RiotGuard,"Tooltip","tooltip_riotGuard_Idle");
            end
        end
    else
        SetOn(RiotGuard,"Tooltip","tooltip_riotGuard_Moving");
    end
-------------------------------------------------------------------------------------------
-- When moved by Player save destination as Idle spot and reset IdleTime time
-------------------------------------------------------------------------------------------   
    if tonumber(RiotGuard.Pos.x) >= tonumber(RiotGuard.PlayerOrderPos.x) - 0.2 and tonumber(RiotGuard.Pos.x) <= tonumber(RiotGuard.PlayerOrderPos.x) + 0.2 and
    tonumber(RiotGuard.Pos.y) >= tonumber(RiotGuard.PlayerOrderPos.y) - 0.2 and tonumber(RiotGuard.Pos.y) <= tonumber(RiotGuard.PlayerOrderPos.y) + 0.2 then
    --Print("Here");
        IdlePosX = RiotGuard.PlayerOrderPos.x;
        IdlePosY = RiotGuard.PlayerOrderPos.y;
        Patroling = true;
        IdleTime = 0;       
    end
-------------------------------------------------------------------------------------------
-- RunAway
-------------------------------------------------------------------------------------------           
    if tonumber(RiotGuard.Damage) >= 0.7 then
        Delete();
    elseif tonumber(RiotGuard.Damage) >= 0.65 then
        RiotGuard.PlayerOrderPos.x = HelicopterPosX;
        RiotGuard.PlayerOrderPos.y = HelicopterPosY;
    end
-------------------------------------------------------------------------------------------
-- End Duty
------------------------------------------------------------------------------------------- 
	if GetFrom(Helicopter,"HeliStatus") == "Waiting" then
		if IdleTime >= Patience then
			Leave();
		end
	end        
    if Get("CanLeave") == true then
        NearByHelicopter = GetObject("Riot_Helicopter",Get("HelicopterID"),2)
        if NearByHelicopter ~= nil then
            Object.Delete(RiotGuard);
            Delete();
        end
    end
-------------------------------------------------------------------------------------------
-- Update
-------------------------------------------------------------------------------------------       
    this.Pos.x = RiotGuard.Pos.x;
    this.Pos.y = RiotGuard.Pos.y;
    IdleTime = IdleTime + timePassed;
end


function LeaveBtnClicked()
	Leave();
end


function Leave()
	this.RemoveInterfaceComponent("LeaveBtn");
	Set("CanLeave",true);
	SetOn(RiotGuard,"Tooltip","tooltip_riotGuard_Leaving");
    RiotGuard.PlayerOrderPos.x = HelicopterPosX;
    RiotGuard.PlayerOrderPos.y = HelicopterPosY;
end
















function Delete()
    local GuardCount = GetFrom(Helicopter,"DeployedGuards");
    SetOn(Helicopter,"DeployedGuards",GuardCount-1);
    Object.Delete(this);
end








    --Helper Functions
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end
-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
    return Object;
end